#!/dls_sw/prod/tools/RHEL5/bin/python2.6

from pkg_resources import require
require('dls_autotestframework')
from dls_autotestframework import TestCase

import re
import subprocess

class alarmAppCaseBase(TestCase):
   """
   Base class for all alarm app test cases.
   This is where the PV is hardcoded to be 'mrkai'
   """
   
   def __init__(self, A):
      TestCase.__init__(self, A)
      self.__pv1 = "mrkai"
      self.__diag = 1
      self.__timeout = 10000
      
   def getPVBase(self):
      return self.__pv1

   def getDiag(self):
      return self.__diag

   def getTimeout(self):
      return self.__timeout

   

class alarmAppCasePerlScript(alarmAppCaseBase):
   """
   Test case to run the original perl script test for alarmApp
   """
   
   def runTest(self):

      #Run the test. Check the return code.
      print "Running alarmApp perl script..."
      ret = subprocess.call("./testAlarmAck.pl mrkai temp.lst", shell=True, cwd="alarmApp")
      if (ret != 0):
         self.fail("Return code of testAlarmAck.pl is not zero.")

      #Check the output with the reference file
      print "Checking output of testAlarmAck.pl against reference file..."
      ret = subprocess.call("diff temp.lst 08JUN2000.lst", shell=True, cwd="alarmApp")
      if (ret != 0):
         self.fail("testAlarmAck.pl output is different from reference file 08JUN2000.lst")
         
      print "Done."
