#!/dls_sw/prod/tools/RHEL5/bin/python2.6

from pkg_resources import require
require('dls_autotestframework')
from dls_autotestframework import TestCase

import re
import subprocess

class convertAppCaseBase(TestCase):
   """
   Base class for all convert app test cases.
   """
   
   def __init__(self, A):
      TestCase.__init__(self, A)
      self.__diag = 1
      self.__timeout = 10000

   def getDiag(self):
      return self.__diag

   def getTimeout(self):
      return self.__timeout

   

class convertAppCaseTestConvert(convertAppCaseBase):
   """
   Test case to run the testConvert program
   """
   
   def runTest(self):

      #Run the test. Check the return code.
      print "Running testConvert..."
      ret = subprocess.call("../../bin/linux-x86/testConvert > temp", shell=True, cwd="iocBoot/iocconvert/")
      if (ret != 0):
         self.fail("Return code of testConvert not zero.")

      #Check the output with the reference file
      print "Checking output of testConvert against reference file..."
      ret = subprocess.call("diff temp 3.14.9-Mx86-Cx86.rpt", shell=True, cwd="iocBoot/iocconvert/")
      if (ret != 0):
         self.fail("testConvert output is different from reference file 3.14.9-Mx86-Cx86.rpt")
         
      print "Done."



class convertAppCaseTestConvertENUM(convertAppCaseBase):
   """
   Test case to run the testConvertENUM program
   """
   
   def runTest(self):

      #Run the test. Check the return code.
      print "Running testConvertENUM..."
      ret = subprocess.call("../../bin/linux-x86/testConvertENUM > temp1", shell=True, cwd="iocBoot/iocconvert/")
      if (ret != 0):
         self.fail("Return code of testConvertENUM not zero.")

      #Check the output with the reference file
      print "Checking output of testConvertENUM against reference file..."
      ret = subprocess.call("diff temp1 29APR1996ENUM.rpt", shell=True, cwd="iocBoot/iocconvert/")
      if (ret != 0):
         self.fail("testConvertENUM output is different from reference file 29APR1996ENUM.rpt")
         
      print "Done."

