/* fdUsage.c - Device Support Routines for vxWorks statistics */

#include <vxWorks.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <version.h>



#ifndef _WRS_VXWORKS_MAJOR
/* vxWorks 5.x or earlier */

#include <private/iosLibP.h>

#define fdInUse(i) fdTable[i].inuse

#else /* !_WRS_VXWORKS_MAJOR */

#include <iosLib.h>

#define maxFiles iosFdMaxFiles()
#define fdInUse(i) iosFdDevFind(i)

#endif /* _WRS_VXWORKS_MAJOR */

int fdUsage(void)
{
    int i, tot;

    printf("maxFiles %d\nIn Use: ", maxFiles);
    for (tot = 0, i = 0; i < maxFiles; i++)  {
	if (fdInUse(i)) {
	    printf("%d ", i);
	    ++tot;
	}
    }
    printf("\nTotal in use %d\n", tot);
    return(0);
}
