#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
 
#include <errlog.h>
#include <epicsExport.h>
#include <epicsThread.h>
#include <epicsExit.h>
#include <iocsh.h>
#define epicsExportSharedSymbols

static volatile int generrMessageContinue = 0;
epicsExportAddress(int, generrMessageContinue);

static void generrMessage(void *pvt)
{
    int okToBlock = *(int *)pvt;
    int number=0;

    epicsThreadSetOkToBlock(okToBlock);
    while (generrMessageContinue) {
        errMessage(number, "errMessage");
        epicsThreadSleep(1.0);
        ++number;
    }
}

static const iocshArg generrMessageArg0 = {"okToBlock", iocshArgInt};
static const iocshArg *const generrMessageArgs[] = {&generrMessageArg0};
static const iocshFuncDef generrMessageDef = {
    "generrMessage",1,generrMessageArgs};
static void generrMessageCall(const iocshArgBuf * args)
{
    int *pint;

    if (generrMessageContinue) {
        generrMessageContinue = 0;
        return;
    } else
        generrMessageContinue = 1;

    pint = calloc(1,sizeof(int));
    *pint = args[0].ival;
    epicsThreadCreate("generrMessage",
        epicsThreadPriorityLow,epicsThreadGetStackSize(epicsThreadStackSmall),
        (EPICSTHREADFUNC)generrMessage,pint);
}

static void stopping(void * dummy) {
    generrMessageContinue = 0;
}

static void generrMessageRegister(void)
{
    iocshRegister(&generrMessageDef,generrMessageCall);
    epicsAtExit(stopping, NULL);
}
epicsExportRegistrar(generrMessageRegister);
