#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>

#include <errlog.h>
#include <epicsExport.h>
#include <epicsThread.h>
#include <epicsExit.h>
#include <iocsh.h>
#define epicsExportSharedSymbols

static volatile int generrlogPrintfContinue = 0;
epicsExportAddress(int, generrlogPrintfContinue);

static void generrlogPrintf(void *pvt)
{
    int delay = *(int *)pvt;
    int number=0;

    if (delay<=.1) delay = .1;
    while (generrlogPrintfContinue) {
        errlogPrintf("errlogPrintf %d\n", number);
        epicsThreadSleep((double)delay);
        ++number;
    }
}

static const iocshArg generrlogPrintfArg0 = {"okToBlock", iocshArgInt};
static const iocshArg *const generrlogPrintfArgs[] = {&generrlogPrintfArg0};
static const iocshFuncDef generrlogPrintfDef = {
    "generrlogPrintf",1,generrlogPrintfArgs};
static void generrlogPrintfCall(const iocshArgBuf * args)
{
    int *pint;

    if (generrlogPrintfContinue) {
        generrlogPrintfContinue = 0;
        return;
    } else
        generrlogPrintfContinue = 1;

    pint = calloc(1,sizeof(int));
    *pint = args[0].ival;
    epicsThreadCreate("generrlogPrintf",
        epicsThreadPriorityLow,epicsThreadGetStackSize(epicsThreadStackSmall),
        (EPICSTHREADFUNC)generrlogPrintf,pint);
}

static void stopping(void * dummy) {
    generrlogPrintfContinue = 0;
}

static void generrlogPrintfRegister(void)
{
    iocshRegister(&generrlogPrintfDef,generrlogPrintfCall);
    epicsAtExit(stopping, NULL);
}
epicsExportRegistrar(generrlogPrintfRegister);
